#!perl -w
# in above -w turns on some warnings

# perl script to back up the cloudy source files onto a different computer
# this is automatically executed once per week, early Saturday morning
# files go to cdrw_dir which should be an accessible cdrw drive,
# and also to out_dir

# bring in the perl module that includes copy
use File::Copy;

# the disk drive where the original files and results live, we will back this up
$c = "c";
# input and output directories
$in_dir = "$c:/projects/cloudy/trunk/tsuite/auto/";

# this is the letter of the cdrw drive on the network 
# this now (mid '05) is on thunder 
# on 05 oct 01 free space on cloudy_bk was 664 mb full space 703mb
$cdrw_dir = "j:/";
# this is the large raid drive on lightning
$out_dir = "r:/usr/gary/backup/cloudy/";

# get current time and date
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
                                            gmtime(time);
# create basename for file
$basename = "$year"."$mon"."$mday" ;

# move to the directory, which contains source.tar and 
if( !chdir( $in_dir ) )
{
   printf(" invalid directory for output of test suite\n");
   printf(" was ==%s==\n",$in_dir );
   # send email  
   send_mail_fail();
   exit(1);
}

# create fully resolved names for where the files will end up
$exe = "$out_dir"."$basename".".exe" ;
$source = "$out_dir"."$basename".".src.tar";
$dat = "$out_dir"."$basename".".data.tar";
$hazy = "$out_dir"."$basename".".hazy.tar";
$agn = "$out_dir"."$basename".".agn.tar";
$tsuite = "$out_dir"."$basename".".tsuite.tar";

# these files live in tsuite/auto and were created by
# last night's run of current\unix\copy_files.pl
if( !copy( "cloudy.exe" , $exe ) )
{
   printf(" weekly backup could not copy cloudy\n");
   send_mail_fail();
   exit(1);
}
if( !copy( "source.tar" , $source ) )
{
   printf(" weekly backup could not copy source\n");
   send_mail_fail();
   exit(1);
}
if( !copy( "data.tar"   , $dat ) )
{
   printf(" weekly backup could not copy data\n");
   send_mail_fail();
   exit(1);
}
if( !copy( "tsuite.tar" , $tsuite ) )
{
   printf(" weekly backup could not copy tsuite\n");
   send_mail_fail();
   exit(1);
}

#=========================================================
# make backup copy of hazy
$hazy_dir= "$c:/projects/";
# move to the hazy directory
if( !chdir( $hazy_dir ) )
{
	printf(" invalid directory for hazy\n");
	printf(" was ==%s==\n",$hazy_dir );
        send_mail_fail();
	exit(1);
}
system( 
"tar_mks -cvf \"$hazy\" hazy/*.doc hazy/*.jnb ");
#=========================================================

#make backup copy of agn
#$agn_dir= "c:/projects/";
#if( !chdir( $agn_dir ) )
#{
#	printf(" invalid directory for agn\n");
#	printf(" was ==%s==\n",$agn_dir );
#	exit(1);
#}
# make backup copy of agn word docs
#system( 
#"tar_mks -cvf \"$agn\" agn/*.doc agn/*/*.doc ");
#=========================================================

# move to the saved files directory on another computer, 
# which contains the tar files we just copied over 
if( !chdir( $out_dir ) )
{
	printf(" invalid directory for output of test suite\n");
	printf(" was ==%s==\n",$out_dir );
        send_mail_fail();
	exit(1);
}
# have to delete existing files since gzip will hang waiting for response on overwrite
if( -e "$tsuite".".gz" )
{
	unlink( "$tsuite".".gz" );
}
if( -e "$exe".".gz" )
{
	unlink( "$exe".".gz" );
}
if( -e "$source".".gz" )
{
	unlink( "$source".".gz" );
}
if( -e "$dat".".gz" )
{
	unlink( "$dat".".gz" );
}
if( -e "$hazy".".gz" )
{
	unlink( "$hazy".".gz" );
}
#if( -e "$agn".".gz" )
#{
#	unlink( "$agn".".gz" );
#}

system( "gzip $exe" );
system( "gzip $tsuite" );
system( "gzip $source" );
system( "gzip $dat" );
system( "gzip $hazy" );
#system( "gzip $agn" );

# copy it to the cdrw 

copy( "$exe.gz"    , $cdrw_dir );
copy( "$tsuite.gz" , $cdrw_dir );
copy( "$source.gz" , $cdrw_dir );
copy( "$dat.gz"    , $cdrw_dir );
copy( "$hazy.gz"   , $cdrw_dir );
#copy( "$agn.gz"    , $cdrw_dir );

# send email does work 
send_mail();
exit;


#=============================================================
#             send_mail(),
#=============================================================

sub send_mail {
 
   open( ioLOG , ">backup.txt" );

   printf( ioLOG " exe, data, and source backed up to thunder.\n");  
   printf( ioLOG " file name was %s\n", $basename) ;
   close( ioLOG );
   system("c:\\u\\blat\\blat.exe backup.txt -t gary\@pa.uky.edu -s CloudyBackup " );
 
}

sub send_mail_fail {
 
   open( ioLOG , ">backup.txt" );

   printf( ioLOG " weekly_backup.pl had trouble doing backups.\n");  
   close( ioLOG );
   system("c:\\u\\blat\\blat.exe backup.txt -t gary\@pa.uky.edu -s CloudyBackup " );
 
}

